
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xaw3d/Form.h>
#include <X11/xv/xvCore.h>
#include <X11/xv/xvForm.h>

// ---------------------------------------------

xvForm::xvForm()
{
	alloc=FALSE;
}

// ---------------------------------------------

xvForm::xvForm(String name, xvCore & parent, Boolean show, Boolean doit)
{
	init(name, parent, show, doit);
}

// ---------------------------------------------

xvForm::~xvForm()
{
	if (alloc) XtDestroyWidget(w);
}

// ---------------------------------------------

void xvForm::init(String name, xvCore & parent, Boolean show, Boolean doit)
{
	w=XtVaCreateWidget(name, formWidgetClass, parent.ID(),
			"resizable", TRUE, NULL);
	DoLayout(doit);
	if (show) ManageChildren();
	alloc=TRUE;
}

// ---------------------------------------------

void xvForm::init(String name, Widget parent, Boolean show, Boolean doit)
{
	w=XtVaCreateWidget(name, formWidgetClass, parent,
			"resizable", TRUE, NULL);
	DoLayout(doit);
	if (show) ManageChildren();
	alloc=TRUE;
}

// ---------------------------------------------

void xvForm::DoLayout(Boolean doit)
{
	XawFormDoLayout(w, doit);
}

// ----------------------------------------------

void xvForm::ManageChildren(Boolean manage)
{
	if (manage)
		XtManageChild(w);
	else
		XtUnmanageChild(w);
}

// ----------------------------------------------
	