
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

#include <stdio.h>
#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include <X11/xv/xvCore.h>
#include <X11/xv/xvPopupShell.h>


// ******************************************************

xvPopupShell::xvPopupShell()
{
	alloc=FALSE;
}

// -----------------------------------------------

xvPopupShell::xvPopupShell(String name, xvCore & parent)
{
	init(name, parent);
}

// -----------------------------------------------

xvPopupShell::~xvPopupShell()
{
	if (alloc) XtDestroyWidget(w);
}

// -----------------------------------------------

void xvPopupShell::PlaceShell()
{
	Position x, y;
	Dimension height;

	XtTranslateCoords(MyParent, 
		(Position) 0, (Position) 0,
		&x, &y);

	XtVaGetValues(MyParent, XtNheight, &height, NULL);

	XtVaSetValues(w, XtNx, x-1, XtNy, y+height, NULL);
}

// -----------------------------------------------

void xvPopupShell::Open()
{

	PlaceShell();
	XtPopup(w, XtGrabExclusive);
}

// ------------------------------------------------
 
void xvPopupShell::Open(Position x, Position y)
{
	XtVaSetValues(w, XtNx, x, XtNy, y, NULL);
	XtPopup(w, XtGrabExclusive);
}

// ----------------------------------------------=

void xvPopupShell::Close()
{
	XtPopdown(w);
}

// -----------------------------------------------

void xvPopupShell::init(String name,  xvCore & parent)
{

	w=XtVaCreatePopupShell(name, overrideShellWidgetClass, parent.ID(), 
		NULL);

	MyParent=parent.ID();
	alloc=TRUE;
}  	

// ------------------------------------------------

void xvPopupShell::init(String name,  xvCore & parent, WidgetClass wid,
				String header, XtTranslations mt)
{

	w=XtVaCreatePopupShell(name, wid, parent.ID(), 
		"label", header,
		"translations", mt,
		NULL);

	MyParent=parent.ID();
	alloc=TRUE;
}  	

// ------------------------------------------------
